Request

Response

    Bid Packages
    PATCH

    bid-packages/{bidPackageId}

    Updates fields in a bid package. The requesting user must be a member of the project team.

    To remove an existing field value, include the field in the request with a value of null.

    Resource Information

    Method and URI
    PATCH
    https://developer.api.autodesk.com/construction/buildingconnected/v2/bid-packages/{bidPackageId}
    Authentication Context
    User context required
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    Content-Type*
    string
    Must be application/json
    * Required

    Request

    URI Parameters

    bidPackageId
    string
    The unique ID of a bid package.

    Request

    Body Structure

    name
    string
    A user-defined name for the bid package, typically referring to a trade or scope of work such as “Concrete” or “Fire Alarms”. The name need not be unique. This value is listed as the trade on the bidder’s opportunity.

    The name must not be empty if provided.

    Max length: 250

    number
    string
    A user-defined identifying number of the bid package. This value need not be unique.
    keywords
    array: string
    An array of keywords to associate with the bid package. Keywords are used by the BuildingConnected search functionality to find relevant bidders for the bid package.

    Note that this value is private to your company and is not displayed to bidders.

    A bid package is limited to a maximum of 4 keywords.

    leadUserId
    string
    The unique BuildingConnected ID of the lead user for this bid package. All opportunities created from this bid package will appear to be sent from this user.

    Max length: 24

    estimatedCost
    number
    A numeric value representing the expected contract cost for the bid package’s scope of work in the associated project’s defaultCurrency.

    Note that this value is private to your company and is not displayed to bidders.

    instructions
    string
    The instructions for what to include in a bid for this bid package. This field may contain HTML tags for formatting.
    bidsDueAt
    datetime: ISO 8601
    The date and time by which bidders must submit their proposals for this bid package, in ISO 8601 format.

    Note that If a project has project.isBiddingSealed set to true, bids cannot be viewed before this date or submitted after this date.

    Note that this field and the useProjectBidsDueAt field are mutually exclusive.

    If bidsDueAt is passed when useProjectBidsDueAt is true, the API will reject the request.

    endsAt
    datetime: ISO 8601
    The expected end date and time of this scope of work, in ISO 8601 format.

    Note that this field and the useProjectEndsAt field are mutually exclusive.

    If endsAt is passed when useProjectEndsAt is true, the API will reject the request.

    If startsAt is set and occurs after endsAt, the API will reject the request.

    rfisDueAt
    datetime: ISO 8601
    The date and time by which bidders must submit their RFIs, in ISO 8601 format.

    Note that this field and the useProjectRfisDueAt field are mutually exclusive.

    If rfisDueAt is passed when useProjectRfisDueAt is true, the API will reject the request.

    startsAt
    datetime: ISO 8601
    The date and time that the scope of work of this bid package is expected to start, in ISO 8601 format.

    Note that this field and the useProjectStartsAt field are mutually exclusive.

    If startsAt is passed when useProjectStartsAt is true, the API will reject the request.

    jobWalkAt
    datetime: ISO 8601
    The date and time that bidders invited to this bid package may come to the site and do a job walk, in ISO 8601 format.

    Note that this field and the useProjectJobWalkAt field are mutually exclusive.

    If jobWalkAt is passed when useProjectJobWalkAt is true, the API will reject the request.

    currentAccDocsFolderId
    string
    The unique ID of an Autodesk Forma Data Management folder in the linked Forma project. Files in this folder are shared with the bid package’s bidders.

    The project to which the bid package belongs must be linked to a Forma project (currentAccLinkedProjectId must have a value) to be able to set this value.

    useProjectBidsDueAt
    boolean
    When set to true, indicates that the bidsDueAt on the Project level will be used for Bid Package bidsDueAt.

    Note that this field and the bidsDueAt field are mutually exclusive.

    useProjectEndsAt
    boolean
    When set to true, indicates that the endsAt on the Project level will be used for Bid Package endsAt.

    Note that this field and the endsAt field are mutually exclusive.

    useProjectJobWalkAt
    boolean
    When set to true, indicates that the jobWalkAt on the Project level will be used for Bid Package jobWalkAt.

    Note that this field and the jobWalkAt field are mutually exclusive.

    useProjectRfisDueAt
    boolean
    When set to true, indicates that the rfisDueAt on the Project level will be used for Bid Package rfisDueAt.

    Note that this field and the rfisDueAt field are mutually exclusive.

    useProjectStartsAt
    boolean
    When set to true, indicates that the startsAt on the Project level will be used for Bid Package startsAt.

    Note that this field and the startsAt field are mutually exclusive.

    Response

    HTTP Status Code Summary

    200
    OK
    OK
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    id
    string
    The bid package’s unique ID.

    Max length: 24

    projectId
    string
    The ID of the project to which the bid package belongs.

    Max length: 24

    name
    string
    The name of the bid package, typically referring to a trade or scope of work such as “Concrete” or “Fire Alarms”. The name need not be unique. This value is listed as the trade on the bidder’s opportunity.
    leadUserId
    string
    The unique BuildingConnected ID of the user set as the “Bid Package Lead”. All opportunities created from this bid package will appear to be sent from this user.

    Max length: 24

    number
    string
    An identifying number of the bid package. This value need not be unique.
    keywords
    array: string
    An array of keywords associated with the bid package. Keywords are used by the BuildingConnected search functionality to find relevant bidders for the bid package.

    Note that this value is private to your company and is not displayed to bidders.

    estimatedCost
    number
    A numeric value representing the expected contract cost for the bid package’s scope of work in the associated project’s defaultCurrency.

    Note that this value is private to your company and is not displayed to bidders.

    instructions
    string
    The instructions for what to include in a bid for this bid package. This field may contain HTML tags for formatting.
    state
    enum:string
    The publication state of the bid package. Possible values:
    • DRAFT: (Default) The bid package has not been published.
    • PUBLISHED: The bid package has been published.
    • PUBLISHING: The bid package is publishing.
    • DUPLICATING: The bid package is duplicating.

    An opportunity is created on a given vendor’s Bid Board when both of the following are true:

    • The bid package is or has been moved to PUBLISHED state.
    • The vendor is or has been added to the bid package.
    createdAt
    datetime: ISO 8601
    The date and time that the bid package was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the bid package was last updated, in ISO 8601 format.
    publishedAt
    datetime: ISO 8601
    The date and time that the bid package was published, in ISO 8601 format.
    bidsDueAt
    datetime: ISO 8601
    The date and time by which bidders must submit their proposals for this bid package, in ISO 8601 format.

    Note that If a project has project.isBiddingSealed set to true, bids cannot be viewed before this date or submitted after this date.

    endsAt
    datetime: ISO 8601
    The date and time that the scope of work of this bid package is expected to be completed, in ISO 8601 format.
    rfisDueAt
    datetime: ISO 8601
    The date and time by which bidders must submit their RFIs for this bid package, in ISO 8601 format.
    startsAt
    datetime: ISO 8601
    The expected start date and time of this scope of work, in ISO 8601 format.
    jobWalkAt
    datetime: ISO 8601
    The date and time that bidders invited to this bid package may come to the site and do a job walk, in ISO 8601 format.
    bidAdminUnsealed
    boolean
    Indicates whether bids have been unsealed for this bid package. Possible values:
    • true: Bids have been unsealed.
    • false: Bids are still sealed.
    bidAdminUnsealedAt
    datetime: ISO 8601
    Date and time that bidAdminUnsealed was set to true, in ISO 8601 format. This value is null if bids are still sealed.
    currentAccDocsFolderId
    string
    The unique ID of an Autodesk Forma Data Management folder in the linked Forma project. Files in this folder are shared with all bidders in this bid package.

    This value is null when currentAccLinkedProjectId is null in the corresponding BuildingConnected project. This value is always optionally null.

    currentAccLinkedProjectId
    string
    The project ID of the Forma project currently linked to from this bid package’s BuildingConnected project.

    Note that when this value is null, currentAccDocsFolderId is also null.

    currentAccLinkedHubId
    string
    The hub ID of the Forma project currently linked to this bid package’s BuildingConnected project. Note that this value is null under any of the following conditions:
    • The value of currentAccLinkedProjectId is null.
    • This project isn’t linked to a Forma project.
    useProjectBidsDueAt
    boolean
    When set to true, indicates that the bidsDueAt on the Project level will be used for Bid Package bidsDueAt.
    useProjectEndsAt
    boolean
    When set to true, indicates that the endsAt on the Project level will be used for Bid Package endsAt.
    useProjectJobWalkAt
    boolean
    When set to true, indicates that the jobWalkAt on the Project level will be used for Bid Package jobWalkAt.
    useProjectRfisDueAt
    boolean
    When set to true, indicates that the rfisDueAt on the Project level will be used for Bid Package rfisDueAt.
    useProjectStartsAt
    boolean
    When set to true, indicates that the startsAt on the Project level will be used for Bid Package startsAt.
    awardedLeveledTotal
    number
    A numeric value representing the total cost of the awarded proposal after bid levelling modifications are included. Combine this value with the project’s defaultCurrency to determine the leveled monetary value of the proposal. This value is null if no bid has been awarded.
    awardedCompany
    object
    Information about a company.
    id
    string
    The unique BuildingConnected ID of the company.

    Max length: 24

    name
    string
    The name of the company.
    avatarImageUrl
    string
    The cached imgix url for the avatar image of the company.
    businessType
    array: string
    The type of business carried out by the company.
    website
    string
    The company’s official website.
    laborType
    array: string
    Specifies the labor payment structure within the company, such as Non-Union or Prevailing Wages.
    enterpriseType
    array: string
    This has been deprecated and replaced with certificates.
    companyTags
    array: string
    A list of tags assigned by your organization to categorize this company. Note that this information is private to your organization and not visible to others.
    certificates
    array: object
    A collection of certificates held by the company. This field replaces the deprecated enterpriseType field.
    id
    string
    The unique identifier for each certificate. Companies can hold multiple certificates, each with its own ID. The field is null for pending certificate suggestions.

    Max length: 24

    type
    object
    Details about the specific type of certificate.
    id
    string
    The unique ID of the certificate type.

    Max length: 24

    name
    string
    The name of the certificate type.
    agency
    object
    Details about the agency that issued the certificate.
    id
    string
    The unique identifier for the certifying agency.

    Max length: 24

    name
    string
    The name of the certifying agency.
    website
    string
    The official website URL of the certifying agency.
    number
    string
    The certificate’s unique identification number.
    expiresAt
    datetime: ISO 8601
    The date the certificate expires, in ISO 8601 format.
    fileName
    string
    The name of the digital copy of the certificate.
    awardedBidId
    string
    The ID of the bid that has been awarded the bid package.

    Max length: 24

    bidFormId
    string
    The unique ID of the bid form associated with this bid package.

    Example

    OK

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/bid-packages/:bidPackageId' \
      -X 'PATCH' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "name": "Concrete",
            "number": "03",
            "keywords": [
              "Concrete"
            ],
            "leadUserId": "5c0dd127b319f408fa90b3bc",
            "estimatedCost": 100000,
            "instructions": "Instruction about bid",
            "bidsDueAt": "2014-09-25T19:00:00.000Z",
            "endsAt": "2014-09-25T19:00:00.000Z",
            "rfisDueAt": "2014-09-25T19:00:00.000Z",
            "startsAt": "2014-09-25T19:00:00.000Z",
            "jobWalkAt": "2014-09-25T19:00:00.000Z",
            "currentAccDocsFolderId": "urn:adsk.wipprod:fs.folder:co.BJU3PTc4Sd2CmXM492XUiA",
            "useProjectBidsDueAt": false,
            "useProjectEndsAt": false,
            "useProjectJobWalkAt": false,
            "useProjectRfisDueAt": false,
            "useProjectStartsAt": false
          }'
    
    Show More

    Response

    {
      "id": "590dd127b359f408f190b5a7",
      "projectId": "590dd127b319f408f190b3b8",
      "name": "Concrete",
      "leadUserId": "5d8104b87e392d56e1e4b4ca",
      "number": "03",
      "keywords": [
        "Concrete"
      ],
      "estimatedCost": 100000,
      "instructions": "Instruction about bid",
      "state": "PUBLISHED",
      "createdAt": "2014-09-25T19:00:00.000Z",
      "updatedAt": "2014-09-26T16:00:00.000Z",
      "publishedAt": "2014-09-25T19:00:00.000Z",
      "bidsDueAt": "2014-09-25T19:00:00.000Z",
      "endsAt": "2014-09-25T19:00:00.000Z",
      "rfisDueAt": "2014-09-25T19:00:00.000Z",
      "startsAt": "2014-09-25T19:00:00.000Z",
      "jobWalkAt": "2014-09-25T19:00:00.000Z",
      "bidAdminUnsealed": true,
      "bidAdminUnsealedAt": "2022-09-25T19:00:00.000Z",
      "currentAccDocsFolderId": "urn:adsk.wipprod:fs.folder:co.9g7HeA2wRqOxLlgLJ40UGQ",
      "currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
      "currentAccLinkedHubId": "28b0d8b3-4730-4f4f-8bad-4a2a5d75ed26",
      "useProjectBidsDueAt": false,
      "useProjectEndsAt": false,
      "useProjectJobWalkAt": false,
      "useProjectRfisDueAt": false,
      "useProjectStartsAt": false,
      "awardedLeveledTotal": 10000,
      "awardedCompany": {
        "id": "51bea397f5846f95994b1da7",
        "name": "Gr8 Builders",
        "avatarImageUrl": "https://www.example.com/",
        "businessType": [
          "Subcontractor"
        ],
        "website": "https://www.example.com",
        "laborType": [
          "Union"
        ],
        "enterpriseType": [
          "Disadvantaged Business Enterprise (DBE)"
        ],
        "companyTags": [
          "example_tag"
        ],
        "certificates": [
          {
            "id": "627074db25c97830ad3ea8c8",
            "type": {
              "id": "59d2bd7440b36a0da258f24d",
              "name": "Disadvantaged Business Enterprise (DBE)"
            },
            "agency": {
              "id": "611d794f7f063800a7274d46",
              "name": "United States Department of Transportation",
              "website": "https://www.transportation.gov/civil-rights/disadvantaged-business-enterprise"
            },
            "number": "12345",
            "expiresAt": "2014-10-03T19:00:00.000Z",
            "fileName": "certificate.pdf"
          }
        ]
      },
      "awardedBidId": "5d8104b87e392d56e1e4b4ca",
      "bidFormId": "60f7c8e2b4d1c9001c8e4b2a"
    }
    
    Show More